// CGWetView.cpp : implementation of the CCGWetView class
//

#include "stdafx.h"
#include <fstream>
#include <iostream>
#include <vector>
#include "CGWet.h"

#include "CGWetDoc.h"
#include "CGWetView.h"
#include ".\cgwetview.h"

using namespace std; 


#define CUSTOM_CLASSNAME _T("CMainFrame")



#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CCGWetView

IMPLEMENT_DYNCREATE(CCGWetView, CView)

BEGIN_MESSAGE_MAP(CCGWetView, CView)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_ACTION_SHOWOVERLAY, OnShowOverlay)
	ON_UPDATE_COMMAND_UI(ID_ACTION_SHOWOVERLAY, OnUpdateOverlay)
	ON_COMMAND(ID_ACTION_SHOWUNION, OnShowUnion)
	ON_UPDATE_COMMAND_UI(ID_ACTION_SHOWUNION, OnUpdateUnion)
	ON_COMMAND(ID_ACTION_SHOWINTERSECTION, OnShowIntersection)
	ON_UPDATE_COMMAND_UI(ID_ACTION_SHOWINTERSECTION, OnUpdateIntersection)
	ON_COMMAND(ID_ACTION_AB, OnShowAB)
	ON_UPDATE_COMMAND_UI(ID_ACTION_AB, OnUpdateAB)
	ON_COMMAND(ID_SHOW_BA, OnShowBA)
	ON_UPDATE_COMMAND_UI(ID_SHOW_BA, OnUpdateBA)
	ON_COMMAND(ID_SHOW_SYMMETRICDIFF, OnShowSymmDiff)
	ON_UPDATE_COMMAND_UI(ID_SHOW_SYMMETRICDIFF, OnUpdateSymmDiff)
END_MESSAGE_MAP()

// CCGWetView construction/destruction

CCGWetView::CCGWetView()
{
	// add construction code here
	xmin=0, xmax=10, ymin=0, ymax=10;
	UserChoice=OVERLAY;
}

CCGWetView::~CCGWetView()
{
}

BOOL CCGWetView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CS_OWNDC);          
 
   // call base class PreCreateWindow to get the cs.lpszClass filled in with the MFC default class name
   if( !CView::PreCreateWindow(cs) )
     return 0;

   // Register the window class if it has not already been registered.
   
   WNDCLASS wndcls;
   HINSTANCE hInst = AfxGetInstanceHandle();

   if(!(::GetClassInfo(hInst, CUSTOM_CLASSNAME, &wndcls)))      // check if our class is registered
   {
     if(::GetClassInfo(hInst, cs.lpszClass, &wndcls))           // get default MFC class settings 
     {
			wndcls.lpszClassName = CUSTOM_CLASSNAME;                // set our class name

			wndcls.style |= CS_OWNDC;			        // change settings for your custom class
			//wndcls.hbrBackground = NULL;

			if (!AfxRegisterClass(&wndcls))                         // register class
				AfxThrowResourceException();				// could not register class
     }
     else
       AfxThrowResourceException();				// default MFC class not registered
    }

    cs.lpszClass = CUSTOM_CLASSNAME;                         // set our class name in CREATESTRUCT

    return 1;                                                   // we're all set*/

}

void CCGWetView::SetDCPixelFormat(CDC* pDC)
{
	int nPixelFormat;

	static PIXELFORMATDESCRIPTOR pfd = {
         sizeof(PIXELFORMATDESCRIPTOR),   // size of structure.
         1,                               // always 1.
         PFD_DRAW_TO_WINDOW |             // support window
         PFD_SUPPORT_OPENGL |             // support OpenGl
         PFD_DOUBLEBUFFER,                // support double buffering
         PFD_TYPE_RGBA,                   // support RGBA
         32,                              // 32 bit color mode
         0, 0, 0, 0, 0, 0,                // ignore color bits
         0,                               // no alpha buffer
         0,                               // ignore shift bit
         0,                               // no accumulation buffer
         0, 0, 0, 0,                      // ignore accumulation bits.
         16,                              // number of depth buffer bits.
         0,                               // number of stencil buffer bits.
         0,                               // 0 means no auxiliary buffer
         PFD_MAIN_PLANE,                  // The main drawing plane
         0,                               // this is reserved
         0, 0, 0 };                       // layer masks ignored.
	
	// Choose a pixel format that best matches that described in pfd
	nPixelFormat = ChoosePixelFormat(pDC->m_hDC, &pfd);

	// Set the pixel format for the device xontext
	int rc = SetPixelFormat(pDC->m_hDC, nPixelFormat, &pfd);
}

const char* getPrimitiveType(GLenum type)
{
	switch(type)
	{
	case 0x0000:
		return "GL_POINTS"; 
		break;
	case 0x0001:
		return "GL_LINES";
		break;
	case 0x0002:
		return "GL_LINE_LOOP";
		break;
	case 0x0003:
		return "GL_LINE_STRIP";
		break;
	case 0x0004:
		return "GL_TRIANGLES";
		break;
	case 0x0005:
		return "GL_TRIANGLE_STRIP";
		break;
	case 0x0006:
		return "GL_TRIANGLE_FAN";
		break;
	case 0x0007:
		return "GL_QUADS";
		break;
	case 0x0008:
		return "GL_QUAD_STRIP";
		break;
	case 0x0009:
		return "GL_POLYGON";
		break;
	}
}

void CALLBACK beginCallback(GLenum which)
{
	glBegin(which);
}

void CALLBACK errorCallback(GLenum errorCode)
{
	const GLubyte *estring;

	estring = gluErrorString(errorCode);
	//fprintf(stderr, "Tessellation Error: %s\n", estring);
	exit(0);
}

void CALLBACK endCallback(void)
{
	glEnd();
}

void CALLBACK vertexCallback(GLvoid *vertex)
{
	GLdouble *ptr;ptr = (GLdouble *) vertex;
	glColor3dv((GLdouble *) ptr + 3);
	glVertex3dv((GLdouble *) ptr);
	GLdouble* banana=(GLdouble *) ptr + 3;
	
}




//use this function to draw your line segments, only within the proper place at CCGWetView::OnDraw
void CCGWetView::DrawLine(double x1, double y1, double x2, double y2, double R, double G, double B)
{
	glColor3d(R,G,B);
	glVertex3d(x1,y1,0);
	glVertex3d(x2,y2,0);
}

void CCGWetView::DrawPoint(double x, double y, double R, double G, double B)
{
	glColor3d(R,G,B);
	glVertex3d(x,y,0);
}


//drawing a polygon (either concave or convex) through a circular list of vertices, which has to be CCW oriented!
void CCGWetView::DrawPolygon(GLUtesselator *tobj, double* Xs, double * Ys, int NumofVertices, double R, double G, double B)
{
	gluTessProperty(tobj, GLU_TESS_WINDING_RULE, GLU_TESS_WINDING_ODD);
	gluTessBeginPolygon(tobj, NULL);
	std::vector<GLdouble*> Coords;
	gluTessBeginContour(tobj);
	for (int i=0;i<NumofVertices;i++){
		GLdouble* NewCoord=new GLdouble[6];
		NewCoord[0]=Xs[i];
		NewCoord[1]=Ys[i];
		NewCoord[2]=0;
		NewCoord[3]=R;
		NewCoord[4]=G;
		NewCoord[5]=B;
		gluTessVertex(tobj, NewCoord, NewCoord);
		Coords.push_back(NewCoord);
	}
	gluTessEndContour(tobj);
	gluTessEndPolygon(tobj);
	while (!Coords.empty()){
		GLdouble* temp=Coords.back();
		delete temp;
		Coords.pop_back();
	}

	//drawing wireframe to polygon
	glBegin(GL_LINE_LOOP);
	glColor3d(0.0,0.0,0.0);
	for (int i=0;i<NumofVertices;i++)
		glVertex3d(Xs[i], Ys[i], 0);
	glEnd();
}


//use this to play with the screen size. The loading initializes it to a fine size,
//but your can use this to scale your object.
void CCGWetView::SetScreenSize(double xmin,double xmax,double ymin,double ymax)
{
	this->xmin=xmin;
	this->ymin=ymin;
	this->xmax=xmax;
	this->ymax=ymax;
}


//R,G,B values are GLdouble values from 0 (dark) to 1 (full intensity)
void CCGWetView::OnDraw(CDC *pDC)
{
	CCGWetDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// Don't notice the code here, unless you're into openGL
	RECT rect;
	CCGWetView::GetClientRect(&rect);
	int w = rect.right - rect.left;
	int h = rect.bottom - rect.top;
	double ratio=(double)h/(double)w;
	glClearColor(1,1,1,1.0f);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	GLUtesselator *tobj = gluNewTess();
	gluTessCallback(tobj, GLU_TESS_VERTEX, 
		(void (__stdcall *)(void))vertexCallback);
	gluTessCallback(tobj, GLU_TESS_BEGIN, 
		(void (__stdcall *)(void))beginCallback);
	gluTessCallback(tobj, GLU_TESS_END, 
		(void (__stdcall *)(void))endCallback);
	gluTessCallback(tobj, GLU_TESS_ERROR, 
		(void (__stdcall *)(void))errorCallback);

	double Spanx=xmax-xmin;
	double Spany=ymax-ymin;
	double Avgx=(xmax+xmin)/2.0;
	double Avgy=(ymax+ymin)/2.0;		
	double MaxSpan=(Spanx>Spany ? Spanx : Spany);
	double minx=Avgx-MaxSpan*1.25; 
	double miny=Avgy-ratio*MaxSpan*1.25;
	double maxx=Avgx+MaxSpan*1.25;
	double maxy=Avgy+ratio*MaxSpan*1.25;
	
	glOrtho(minx,maxx,miny,maxy,-1.0, 1.0);

	glViewport(0,0,w,h);
	glLineWidth(1.0);
	glPointSize(2.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glLineWidth(2.0);   //alter the line width here
	glBegin(GL_LINES);

	//put all DrawLine() calls in here alone! the order doesn't matter, but every line
	//you'd like to draw concurrently on screen should be coded here

	//an example:
	DrawLine(0,0,10,10,1.0,0.5,0.0);
	DrawLine(10,0,0,10,0.0,0.5,1.0);

	glEnd();

	glPointSize(5.0);  //you can alter the point size here
	glBegin(GL_POINTS);

	//put all DrawPoint() functions here
	DrawPoint(2,3,1.0,0.0,1.0);
	glEnd();

	//put all DrawPolygon() functions here:
	double Xs[]={4, 6, 6, 5, 4};
	double Ys[]={2, 2, 4, 3, 4};
	DrawPolygon(tobj, Xs, Ys, 5, 0.1, 0.5, 0.3);
	//in order to draw holes just draw inner white polygons on top (don't forgot to use CCW orientation despite the orientation of the hole)
	double hXs[]={4.5, 5.5, 5.5, 4.5};
	double hYs[]={2.5, 2.5, 2.8, 2.8};
	DrawPolygon(tobj, hXs, hYs, 4, 1, 1, 1);

	gluDeleteTess(tobj);
	glFlush();
	SwapBuffers(pDC->m_hDC);
	
}


// CCGWetView diagnostics

#ifdef _DEBUG
void CCGWetView::AssertValid() const
{
	CView::AssertValid();
}

void CCGWetView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCGWetDoc* CCGWetView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCGWetDoc)));
	return (CCGWetDoc*)m_pDocument;
}
#endif //_DEBUG


// CCGWetView message handlers

void CCGWetView::OnFileOpen()
{
	// TODO: Add your command handler code here
	TCHAR szFilters[] = _T ("CGWet 2-Polygon data files (*.plg)|*.plg|All Files (*.*)|*.*||");
	CString tmpFilename;

	CFileDialog dlg(TRUE, "plg", "*.plg", OFN_FILEMUSTEXIST | OFN_HIDEREADONLY ,szFilters);

	if (dlg.DoModal () == IDOK) {
		tmpFilename = dlg.GetPathName();		// Keep full path and filename

		/*This is the code for reading the *.plg file into arrays of points. In order to
		  get the i'th coordinate, take (x[i],y[i])*/

		int NumofPoints1, NumofPoints2;
		double *x1, *y1, *x2, *y2;
		
		ifstream FileName;
		FileName.open(tmpFilename);
		//first polygon
		FileName>>NumofPoints1;
		x1=new double[NumofPoints1];
		y1=new double[NumofPoints1];
		ymin=xmin=32767; ymax=xmax=-32767;
		for (int i=0;i<NumofPoints1;i++){
			FileName>>x1[i]>>y1[i];
			if (x1[i]<xmin) xmin=x1[i];
			if (y1[i]<ymin) ymin=y1[i];
			if (x1[i]>xmax) xmax=x1[i];
			if (y1[i]>ymax) ymax=y1[i];
		}

		FileName>>NumofPoints2;
		x2=new double[NumofPoints2];
		y2=new double[NumofPoints2];
		for (int i=0;i<NumofPoints2;i++){
			FileName>>x2[i]>>y2[i];
			if (x2[i]<xmin) xmin=x2[i];
			if (y2[i]<ymin) ymin=y2[i];
			if (x2[i]>xmax) xmax=x2[i];
			if (y2[i]>ymax) ymax=y2[i];
		}
		//adding 10% on each side (in order the view the side cells better)
		xmin=xmin-0.1*(xmax-xmin);
		ymin=ymin-0.1*(ymax-ymin);
		xmax=xmax+0.1*(xmax-xmin);
		ymax=ymax+0.1*(ymax-ymin);
		FileName.close();

		//Put your data initialization code here (do not reuse x1,y1,x2,y2 after initializing because they are
		//deleted next...

		
		/*********/
		delete[] x1;
		delete[] y1;
		delete[] x2;
		delete[] y2;
	}
}

//do here the actions required when user presses show->some user choice in the menu. The choice is stored
//in the variable UserChoice

void CCGWetView::OnUserChoice()
{
	//your code
}


//////////////code parts you need not worry about

int CCGWetView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	CClientDC dc(this) ;
	SetDCPixelFormat((CDC*)&dc);
	m_hrc = wglCreateContext(dc.m_hDC);
	
	return 0;
}

void CCGWetView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	wglMakeCurrent(GetDC()->m_hDC,m_hrc);
}

void CCGWetView::OnDestroy()
{
	wglMakeCurrent(NULL, NULL) ;	
	wglDeleteContext(wglGetCurrentContext()) ;
	CView::OnDestroy();
}

void CCGWetView::OnShowOverlay()
{
	UserChoice=OVERLAY;
	OnUserChoice();
}

void CCGWetView::OnUpdateOverlay(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(UserChoice==OVERLAY);
}

void CCGWetView::OnShowUnion()
{
	UserChoice=UNION;
	OnUserChoice();
}

void CCGWetView::OnUpdateUnion(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(UserChoice==UNION);
}
	

void CCGWetView::OnShowIntersection()
{
	UserChoice=INTERSECTION;
	OnUserChoice();
}

void CCGWetView::OnUpdateIntersection(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(UserChoice==INTERSECTION);
}

void CCGWetView::OnShowAB()
{
	UserChoice=A_DIFF;
	OnUserChoice();
}

void CCGWetView::OnUpdateAB(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(UserChoice==A_DIFF);
}

void CCGWetView::OnShowBA()
{
	UserChoice=B_DIFF;
	OnUserChoice();
}

void CCGWetView::OnUpdateBA(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(UserChoice==B_DIFF);
}

void CCGWetView::OnShowSymmDiff()
{
	UserChoice=SYMM_DIFF;
	OnUserChoice();
}

void CCGWetView::OnUpdateSymmDiff(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(UserChoice==SYMM_DIFF);
}

